/*
 **
 ** pinmux_config.c source file generated on January 20, 2015 at 11:11:20.	
 **
 ** Copyright (C) 2000-2015 Analog Devices Inc., All Rights Reserved.
 **
 ** This file is generated automatically based upon the options selected in 
 ** the Pin Multiplexing configuration editor. Changes to the Pin Multiplexing
 ** configuration should be made by changing the appropriate options rather
 ** than editing this file.
 **
 ** Selected Peripherals
 ** --------------------
 ** PPI0 (FS1, FS2, FS3, CLK, D00, D01, D02, D03, D04, D05, D06, D07, D08, D09, D10, D11, D12, D13, D14, D15, D16, D17)
 **
 ** GPIO (unavailable)
 ** ------------------
 ** PA08, PA09, PA10, PA11, PA12, PA13, PA14, PA15, PB00, PB01, PB02, PB03, PB04,
 ** PB05, PB06, PB07, PB08, PB09, PC00, PC01, PC02, PC03
 */

#include <sys/platform.h>
#include <stdint.h>

#define PPI0_FS1_PORTA_MUX  ((uint32_t) ((uint32_t) 0<<24))
#define PPI0_FS2_PORTA_MUX  ((uint32_t) ((uint32_t) 0<<26))
#define PPI0_FS3_PORTA_MUX  ((uint32_t) ((uint32_t) 0<<30))
#define PPI0_CLK_PORTA_MUX  ((uint32_t) ((uint32_t) 0<<28))
#define PPI0_D00_PORTB_MUX  ((uint16_t) ((uint16_t) 0<<14))
#define PPI0_D01_PORTB_MUX  ((uint16_t) ((uint16_t) 0<<12))
#define PPI0_D02_PORTB_MUX  ((uint16_t) ((uint16_t) 0<<10))
#define PPI0_D03_PORTB_MUX  ((uint16_t) ((uint16_t) 0<<8))
#define PPI0_D04_PORTB_MUX  ((uint16_t) ((uint16_t) 0<<6))
#define PPI0_D05_PORTB_MUX  ((uint16_t) ((uint16_t) 0<<4))
#define PPI0_D06_PORTB_MUX  ((uint16_t) ((uint16_t) 0<<2))
#define PPI0_D07_PORTB_MUX  ((uint16_t) ((uint16_t) 0<<0))
#define PPI0_D08_PORTA_MUX  ((uint32_t) ((uint32_t) 0<<22))
#define PPI0_D09_PORTA_MUX  ((uint32_t) ((uint32_t) 0<<20))
#define PPI0_D10_PORTA_MUX  ((uint32_t) ((uint32_t) 0<<18))
#define PPI0_D11_PORTA_MUX  ((uint32_t) ((uint32_t) 0<<16))
#define PPI0_D12_PORTC_MUX  ((uint16_t) ((uint16_t) 2<<6))
#define PPI0_D13_PORTC_MUX  ((uint16_t) ((uint16_t) 2<<4))
#define PPI0_D14_PORTC_MUX  ((uint16_t) ((uint16_t) 2<<2))
#define PPI0_D15_PORTC_MUX  ((uint16_t) ((uint16_t) 2<<0))
#define PPI0_D16_PORTB_MUX  ((uint32_t) ((uint32_t) 1<<16))
#define PPI0_D17_PORTB_MUX  ((uint32_t) ((uint32_t) 1<<18))

#define PPI0_FS1_PORTA_FER  ((uint32_t) ((uint32_t) 1<<12))
#define PPI0_FS2_PORTA_FER  ((uint32_t) ((uint32_t) 1<<13))
#define PPI0_FS3_PORTA_FER  ((uint32_t) ((uint32_t) 1<<15))
#define PPI0_CLK_PORTA_FER  ((uint32_t) ((uint32_t) 1<<14))
#define PPI0_D00_PORTB_FER  ((uint16_t) ((uint16_t) 1<<7))
#define PPI0_D01_PORTB_FER  ((uint16_t) ((uint16_t) 1<<6))
#define PPI0_D02_PORTB_FER  ((uint16_t) ((uint16_t) 1<<5))
#define PPI0_D03_PORTB_FER  ((uint16_t) ((uint16_t) 1<<4))
#define PPI0_D04_PORTB_FER  ((uint16_t) ((uint16_t) 1<<3))
#define PPI0_D05_PORTB_FER  ((uint16_t) ((uint16_t) 1<<2))
#define PPI0_D06_PORTB_FER  ((uint16_t) ((uint16_t) 1<<1))
#define PPI0_D07_PORTB_FER  ((uint16_t) ((uint16_t) 1<<0))
#define PPI0_D08_PORTA_FER  ((uint32_t) ((uint32_t) 1<<11))
#define PPI0_D09_PORTA_FER  ((uint32_t) ((uint32_t) 1<<10))
#define PPI0_D10_PORTA_FER  ((uint32_t) ((uint32_t) 1<<9))
#define PPI0_D11_PORTA_FER  ((uint32_t) ((uint32_t) 1<<8))
#define PPI0_D12_PORTC_FER  ((uint16_t) ((uint16_t) 1<<3))
#define PPI0_D13_PORTC_FER  ((uint16_t) ((uint16_t) 1<<2))
#define PPI0_D14_PORTC_FER  ((uint16_t) ((uint16_t) 1<<1))
#define PPI0_D15_PORTC_FER  ((uint16_t) ((uint16_t) 1<<0))
#define PPI0_D16_PORTB_FER  ((uint32_t) ((uint32_t) 1<<8))
#define PPI0_D17_PORTB_FER  ((uint32_t) ((uint32_t) 1<<9))

int32_t adi_initpinmux(void);

/*
 * Initialize the Port Control MUX and FER Registers
 */
int32_t adi_initpinmux(void) {
    /* PORTx_MUX registers */
    *pREG_PORTA_MUX = PPI0_FS1_PORTA_MUX | PPI0_FS2_PORTA_MUX
     | PPI0_FS3_PORTA_MUX | PPI0_CLK_PORTA_MUX | PPI0_D08_PORTA_MUX
     | PPI0_D09_PORTA_MUX | PPI0_D10_PORTA_MUX | PPI0_D11_PORTA_MUX;
    *pREG_PORTB_MUX = PPI0_D00_PORTB_MUX | PPI0_D01_PORTB_MUX
     | PPI0_D02_PORTB_MUX | PPI0_D03_PORTB_MUX | PPI0_D04_PORTB_MUX
     | PPI0_D05_PORTB_MUX | PPI0_D06_PORTB_MUX | PPI0_D07_PORTB_MUX
     | PPI0_D16_PORTB_MUX | PPI0_D17_PORTB_MUX;
    *pREG_PORTC_MUX = PPI0_D12_PORTC_MUX | PPI0_D13_PORTC_MUX
     | PPI0_D14_PORTC_MUX | PPI0_D15_PORTC_MUX;

    /* PORTx_FER registers */
    *pREG_PORTA_FER = PPI0_FS1_PORTA_FER | PPI0_FS2_PORTA_FER
     | PPI0_FS3_PORTA_FER | PPI0_CLK_PORTA_FER | PPI0_D08_PORTA_FER
     | PPI0_D09_PORTA_FER | PPI0_D10_PORTA_FER | PPI0_D11_PORTA_FER;
    *pREG_PORTB_FER = PPI0_D00_PORTB_FER | PPI0_D01_PORTB_FER
     | PPI0_D02_PORTB_FER | PPI0_D03_PORTB_FER | PPI0_D04_PORTB_FER
     | PPI0_D05_PORTB_FER | PPI0_D06_PORTB_FER | PPI0_D07_PORTB_FER
     | PPI0_D16_PORTB_FER | PPI0_D17_PORTB_FER;
    *pREG_PORTC_FER = PPI0_D12_PORTC_FER | PPI0_D13_PORTC_FER
     | PPI0_D14_PORTC_FER | PPI0_D15_PORTC_FER;
    return 0;
}

